package Collections

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_lists.htm
 */
class Lists {
	fun main1() {
		val theList = listOf("one", "two", "three", "four")
		println(theList)
		val theMutableList = mutableListOf("one", "two", "three", "four")
		println(theMutableList)
	}

	fun main2() {
		val theList = listOf("one", "two", "three", "four")
		println(theList.toString())
	}

	fun main3() {
		val theList = listOf("one", "two", "three", "four")
		val itr = theList.listIterator()
		while (itr.hasNext()) {
			println(itr.next())
		}
	}

	fun main4() {
		val theList = listOf("one", "two", "three", "four")
		for (i in theList.indices) {
			println(theList[i])
		}
	}

	fun main5() {
		val theList = listOf("one", "two", "three", "four")
		theList.forEach {
			println(it)
		}
	}

	fun main6() {
		val theList = listOf("one", "two", null, "four", "five")
		println("Size of the list " + theList.size)
	}

	fun main7() {
		val theList = listOf("one", "two", "three", "four")
		if ("two" in theList) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main8() {
		val theList = listOf("one", "two", "three", "four")
		if (theList.contains("two")) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main9() {
		val theList = listOf("one", "two", "three", "four")
		if (theList.isEmpty()) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main10() {
		val theList = listOf("one", "two", "three", "four")
		println("Index of 'two' : " + theList.indexOf("two"))
	}

	fun main11() {
		val theList = listOf("one", "two", "three", "four")
		println("Element at 3rd position " + theList.get(2))
	}

	fun main12() {
		val firstList = listOf("one", "two", "three")
		val secondList = listOf("four", "five", "six")
		val resultList = firstList + secondList
		println(resultList)
	}

	fun main13() {
		val firstList = listOf("one", "two", "three")
		val secondList = listOf("one", "five", "six")
		val resultList = firstList - secondList
		println(resultList)
	}

	fun main14() {
		val theList = listOf("one", "two", "three", "four", "five")
		val resultList = theList.slice(2..4)
		println(resultList)
	}

	fun main15() {
		val theList = listOf("one", "two", null, "four", "five")
		val resultList = theList.filterNotNull()
		println(resultList)
	}

	fun main16() {
		val theList = listOf(10, 20, 30, 31, 40, 50, -1, 0)
		val resultList = theList.filter { it > 30 }
		println(resultList)
	}

	fun main17() {
		val theList = listOf(10, 20, 30, 31, 40, 50, -1, 0)
		val resultList = theList.drop(3)
		println(resultList)
	}

	fun main18() {
		val theList = listOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultList = theList.groupBy { it % 3 }
		println(resultList)
	}

	fun main19() {
		val theList = listOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultList = theList.map { it / 3 }
		println(resultList)
	}

	fun main20() {
		val theList = listOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultList = theList.chunked(3)
		println(resultList)
	}

	fun main21() {
		val theList = listOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultList = theList.windowed(3)
		println(resultList)
	}

	fun main22() {
		val theList = listOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultList = theList.windowed(3, 3)
		println(resultList)
	}

	fun main23() {
		val theList = mutableSetOf(
			10,
			20,
			30
		)
		theList.add(40)
		theList.add(50)
		println(theList)
		theList.remove(10)
		theList.remove(30)
		println(theList)
	}
}
