package Collections

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_maps.htm
 */
class Maps {
	fun main1() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		println(theMap)
		val theMutableMap = mutableSetOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		println(theMutableMap)
	}

	fun main2() {
		val theMap = HashMap<String, Int>()
		theMap["one"] = 1
		theMap["two"] = 2
		theMap["three"] = 3
		theMap["four"] = 4
		println(theMap)
	}

	fun main3() {
		val theMap = mapOf(
			Pair("one", 1),
			Pair("two", 2),
			Pair("three", 3)
		)
		println(theMap)
	}

	fun main4() {
		val theMap = mapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		println("Entries: " + theMap.entries)
		println("Keys:" + theMap.keys)
		println("Values:" + theMap.values)
	}

	fun main5() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		println(theMap.toString())
	}

	fun main6() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		val itr = theMap.keys.iterator()
		while (itr.hasNext()) {
			val key = itr.next()
			val value = theMap[key]
			println("${key}=$value")
		}
	}

	fun main7() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		for ((k, v) in theMap) {
			println("$k = $v")
		}
	}

	fun main8() {
		val theMap = mapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		theMap.forEach { k, v ->
			println("Key = $k, Value = $v")
		}
	}

	fun main9() {
		val theMap = mapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		println("Size of the Map " + theMap.size)
		println("Size of the Map " + theMap.count())
	}

	fun main10() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		if (theMap.containsKey("two")) {
			println(true)
		} else {
			println(false)
		}
		if (theMap.containsValue(2)) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main11() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		if (theMap.isEmpty()) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main12() {
		val theMap = mapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		println("The value for key two " + theMap.get("two"))
		println("The value for key two " + theMap["two"])
	}

	fun main13() {
		val firstMap = mapOf("one" to 1, "two" to 2, "three" to 3)
		val secondMap = mapOf("one" to 10, "four" to 4)
		val resultMap = firstMap + secondMap
		println(resultMap)
	}

	fun main14() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3)
		val theKeyList = listOf("one", "four")
		val resultMap = theMap - theKeyList
		println(resultMap)
	}

	fun main15() {
		val theMap = mutableMapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		theMap.remove("two")
		println(theMap)
		theMap -= listOf("three")
		println(theMap)
	}

	fun main16() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		var resultMap = theMap.toSortedMap()
		println(resultMap)
	}

	fun main17() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3, "four" to 4)
		var resultMap = theMap.filterValues { it > 2 }
		println(resultMap)
		resultMap = theMap.filterKeys { it == "two" }
		println(resultMap)
		resultMap = theMap.filter { it.key == "two" || it.value == 4 }
		println(resultMap)
	}

	fun main18() {
		val theMap = mapOf("one" to 1, "two" to 2, "three" to 3)
		val resultMap = theMap.map { (k, v) -> "Key is $k, Value is $v" }
		println(resultMap)
	}

	fun main19() {
		val theMap = mutableMapOf(
			"one" to 1,
			"two" to 2,
			"three" to 3,
			"four" to 4
		)
		theMap.put("four", 4)
		println(theMap)
		theMap["five"] = 5
		println(theMap)
		theMap.remove("two")
		println(theMap)
	}
}
