package Collections

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_sets.htm
 */
class Sets {
	fun main1() {
		val theSet = setOf("one", "two", "three", "four")
		println(theSet)
		val theMutableSet = mutableSetOf("one", "two", "three", "four")
		println(theMutableSet)
	}

	fun main2() {
		val theSet = setOf("one", "two", "three", "four")
		println(theSet.toString())
	}

	fun main3() {
		val theSet = setOf("one", "two", "three", "four")
		val itr = theSet.asIterable().iterator()
		while (itr.hasNext()) {
			println(itr.next())
		}
	}

	fun main4() {
		val theSet = setOf("one", "two", "three", "four")
		for (i in theSet.indices) {
			println(theSet.elementAt(i))
		}
	}

	fun main5() {
		val theSet = setOf("one", "two", "three", "four")
		theSet.forEach {
			println(it)
		}
	}

	fun main6() {
		val theSet = setOf("one", "two", null, "four", "five")
		println("Size of the Set " + theSet.size)
	}

	fun main7() {
		val theSet = setOf("one", "two", "three", "four")
		if ("two" in theSet) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main8() {
		val theSet = setOf("one", "two", "three", "four")
		if (theSet.contains("two")) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main9() {
		val theSet = setOf("one", "two", "three", "four")
		if (theSet.isEmpty()) {
			println(true)
		} else {
			println(false)
		}
	}

	fun main10() {
		val theSet = setOf("one", "two", "three", "four")
		println("Index of 'two' - " + theSet.indexOf("two"))
	}

	fun main11() {
		val theSet = setOf("one", "two", "three", "four")
		println("Element at 3rd position " + theSet.elementAt(2))
	}

	fun main12() {
		val firstSet = setOf("one", "two", "three")
		val secondSet = setOf("one", "four", "five", "six")
		val resultSet = firstSet + secondSet
		println(resultSet)
	}

	fun main13() {
		val firstSet = setOf("one", "two", "three")
		val secondSet = setOf("one", "five", "six")
		val resultSet = firstSet - secondSet
		println(resultSet)
	}

	fun main14() {
		val theSet = setOf("one", "two", null, "four", "five")
		val resultSet = theSet.filterNotNull()
		println(resultSet)
	}

	fun main15() {
		val theSet = setOf(10, 20, 30, 31, 40, 50, -1, 0)
		var resultSet = theSet.sorted()
		println(resultSet)
		resultSet = theSet.sortedDescending()
		println(resultSet)
	}

	fun main16() {
		val theSet = setOf(10, 20, 30, 31, 40, 50, -1, 0)
		val resultSet = theSet.filter { it > 30 }
		println(resultSet)
	}

	fun main17() {
		val theSet = setOf(10, 20, 30, 31, 40, 50, -1, 0)
		val resultSet = theSet.drop(3)
		println(resultSet)
	}

	fun main18() {
		val theSet = setOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultSet = theSet.groupBy { it % 3 }
		println(resultSet)
	}

	fun main19() {
		val theSet = setOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultSet = theSet.map { it / 3 }
		println(resultSet)
	}

	fun main20() {
		val theSet = setOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultSet = theSet.chunked(3)
		println(resultSet)
	}

	fun main21() {
		val theSet = setOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultSet = theSet.windowed(3)
		println(resultSet)
	}

	fun main22() {
		val theSet = setOf(10, 12, 30, 31, 40, 9, -3, 0)
		val resultSet = theSet.windowed(3, 3)
		println(resultSet)
	}

	fun main23() {
		val theSet = mutableSetOf(
			10,
			20,
			30
		)
		theSet.add(40)
		theSet.add(50)
		println(theSet)
		theSet.remove(10)
		theSet.remove(30)
		println(theSet)
	}
}
