package ControlFlow

/**
 * https://www.tutorialspoint.com/kotlin/kotlin_when_expression.htm
 */
class WhenStatements {
	fun main1(args: Array<String>) {
		val day = 2
		val result = when (day) {
			1 -> "Monday"
			2 -> "Tuesday"
			3 -> "Wednesday"
			4 -> "Thursday"
			5 -> "Friday"
			6 -> "Saturday"
			7 -> "Sunday"
			else -> "Invalid day."
		}
		println(result)
	}

	fun main2(args: Array<String>) {
		val day = 2
		when (day) {
			1 -> println("Monday")
			2 -> println("Tuesday")
			3 -> println("Wednesday")
			4 -> println("Thursday")
			5 -> println("Friday")
			6 -> println("Saturday")
			7 -> println("Sunday")
			else -> println("Invalid day.")
		}
	}

	fun main3(args: Array<String>) {
		val day = 2
		when (day) {
			1, 2, 3, 4, 5 -> println("Weekday")
			else -> println("Weekend")
		}
	}

	fun main4(args: Array<String>) {
		val day = 2
		when (day) {
			in 1..5 -> println("Weekday")
			else -> println("Weekend")
		}
	}

	fun main5(args: Array<String>) {
		val x = 20
		val y = 10
		val z = 10
		when (x) {
			(y + z) -> print("y + z = x = $x")
			else -> print("Condition is not satisfied")
		}
	}

	fun main6(args: Array<String>) {
		val day = 2
		when (day) {
			1 -> {
				println("First day of the week")
				println("Monday")
			}
			2 -> {
				println("Second day of the week")
				println("Tuesday")
			}
			3 -> {
				println("Third day of the week")
				println("It is Wednesday, my dudes!")
			}
			4 -> println("Thursday")
			5 -> println("Friday")
			6 -> println("Saturday")
			7 -> println("Sunday")
			else -> println("Invalid day.")
		}
	}

}
